<?php
/*
Plugin Name: Online Status inSL
Plugin URI: http://gwynethllewelyn.net/online-status-insl/
Version: 0.9.1
License: Simplified BSD License
Author: Gwyneth Llewelyn
Author URI: http://gwynethllewelyn.net/
Description: Shows your online status in the Second Life® world on a widget 

Copyright 2011 Gwyneth Llewelyn. All rights reserved.

Tweaks by SignpostMarv

Redistribution and use in source and binary forms, with or without modification, are
permitted provided that the following conditions are met:

   1. Redistributions of source code must retain the above copyright notice, this list of
      conditions and the following disclaimer.

   2. Redistributions in binary form must reproduce the above copyright notice, this list
      of conditions and the following disclaimer in the documentation and/or other materials
      provided with the distribution.

THIS SOFTWARE IS PROVIDED BY GWYNETH LLEWELYN ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL GWYNETH LLEWELYN OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those of the
authors and should not be interpreted as representing official policies, either expressed
or implied, of Gwyneth Llewelyn.

---

Based on code developed by Dave Doolin, http://website-in-a-weekend.net/extending-wordpress/wordpress-widget-plugin-super-easy-customization-tuesday-means-technical/

*/

if (!class_exists("online_status_insl")) {
 
	class online_status_insl extends WP_Widget {
 
		function online_status_insl()
		{
			$widget_ops = array('classname' => 'online_status_insl', 'description' => 'Online Status inSL' );
			$this->WP_Widget('online_status_insl_widget', 'Online Status inSL Widget', $widget_ops);
		}
 
		/* This is the code that gets displayed on the UI side,
		 * what readers see.
		 */
		function widget($args, $instance)
		{
			extract($args, EXTR_SKIP);
			echo $before_widget;
			$title = empty($instance['title']) ? '&nbsp;' : apply_filters('widget_title', $instance['title']);
 
			if (!empty($title)) { 
				echo $before_title,$title,$after_title;
			}
			
			// Code to check the in-world thingy and spew out results
					
			$channel = file_get_contents(ABSPATH . 'wp-content/uploads/channel.inc');
			
			if ($channel) // See first if we ever got a channel UUID for the in-world object
			{
				include_once(ABSPATH . WPINC . '/class-IXR.php');
				$client = new IXR_Client('http://xmlrpc.secondlife.com/cgi-bin/xmlrpc.cgi');

				$payload["Channel"] = $channel;
				$payload["IntValue"] = 0;
				$payload["StringValue"] = "online status";
	
				print $instance['before_status'];
				if ($client->query('llRemoteData', $payload))
				{
	    			$response = $client->getResponse();
	    			print $response["StringValue"] . $instance['after_status'];
				}
				else
				{
	    			print $instance['having_problems'];
				}
			}
			else
			{
				print $instance['unconfigured'];
			}
			
			// return to widget handling code
            echo $after_widget;
		}
 
		function update($new_instance, $old_instance) {
			$instance = $old_instance;
			$instance['title'] = strip_tags($new_instance['title']);
			$instance['before_status'] = strip_tags($new_instance['before_status']);
			$instance['after_status'] = strip_tags($new_instance['after_status']);
			$instance['having_problems'] = strip_tags($new_instance['having_problems']);
			$instance['unconfigured'] = strip_tags($new_instance['unconfigured']);
			return $instance;
		}
 
		/* Back end, the interface shown in Appearance -> Widgets
		 * administration interface.
		 */
		function form($instance) {
			$defaults = array(
				'title' => __('Second Life Online Status'), 
				'before_status' => __('I am '), 
				'after_status' => __(' in Second Life.'),
				'having_problems' => __('having problems contacting RPC server...'),
				'unconfigured' => __('Please set up your in-world object first')
			);
		
			$instance = wp_parse_args((array) $instance, $defaults);
					
			$title = strip_tags($instance['title']);
			?>
 
<p>
<label for="<?php echo esc_attr($this->get_field_id('title')); ?>"><?php _e("Title"); ?>: 
    <input
	   class="widefat" id="<?php echo esc_attr($this->get_field_id('title')); ?>"
	   name="<?php echo esc_attr($this->get_field_name('title')); ?>" type="text"
	   value="<?php echo esc_attr($title); ?>" 
	/>
</label>
<label for="<?php echo esc_attr($this->get_field_id('before_status')); ?>"><?php _e("Before status message"); ?>: 
    <input
	   class="widefat" id="<?php echo esc_attr($this->get_field_id('before_status')); ?>"
	   name="<?php echo esc_attr($this->get_field_name('before_status')); ?>" type="text"
	   value="<?php echo esc_attr($instance['before_status']); ?>" 
	/>
</label>
<label for="<?php echo esc_attr($this->get_field_id('after_status')); ?>"><?php _e("After status message"); ?>: 
    <input
	   class="widefat" id="<?php echo esc_attr($this->get_field_id('after_status')); ?>"
	   name="<?php echo esc_attr($this->get_field_name('after_status')); ?>" type="text"
	   value="<?php echo esc_attr($instance['after_status']); ?>" 
	/>
</label>
<label for="<?php echo esc_attr($this->get_field_id('having_problems')); ?>"><?php _e("Error message when communicating with SL"); ?>: 
    <input
	   class="widefat" id="<?php echo esc_attr($this->get_field_id('having_problems')); ?>"
	   name="<?php echo esc_attr($this->get_field_name('having_problems')); ?>" type="text"
	   value="<?php echo esc_attr($instance['having_problems']); ?>" 
	/>
</label>
<label for="<?php echo esc_attr($this->get_field_id('unconfigured')); ?>"><?php _e("Widget not configured message"); ?>: 
    <input
	   class="widefat" id="<?php echo esc_attr($this->get_field_id('unconfigured')); ?>"
	   name="<?php echo esc_attr($this->get_field_name('unconfigured')); ?>" type="text"
	   value="<?php echo esc_attr($instance['unconfigured']); ?>" 
	/>
</label>
</p>
 
			<?php
		}			
	}
 
	function online_status_insl_widget_init()
	{
		register_widget('online_status_insl');
	}

	function online_status_insl_widget_activate()
	{
		file_put_contents(ABSPATH . 'wp-content/uploads/channel.inc', "");
	}

	function online_status_insl_widget_deactivate()
	{
		unlink(ABSPATH . 'wp-content/uploads/channel.inc'); // keep it tidy
	}
	
	function online_status_insl_admin_menu_options()
	{
		add_options_page('Online Status inSL', 'Online Status inSL', 1,
			'online_status_insl', 'online_status_insl_menu');
	}
	
	function online_status_insl_menu()
	{
?>
<div class="wrap">
<h2>Online Status inSL</h2>
<?php _e("Please create an object in Second Life on a plot owned by you, and drop the following script inside:"); ?>
<p>
<pre>
// Code by Gwyneth Llewelyn to show online status and let it
// be retrieved by external XML-RPC calls
// Global Variables
key avatar;
string avatarName;
string onlineStatus = "status unknown"; // preserve it
key onlineStatusRequest;
key webResponse;    // we send the RPC channel ID to the webserver

// modified by SignpostMarv
string http_host = "<?php echo esc_attr($_SERVER['HTTP_HOST']); ?>";

default
{
    state_entry()
    {
        llSetTimerEvent(60.0);  // call a timer event
                        // every 60 seconds.
        avatar = llGetOwner();
        avatarName = llKey2Name(avatar);
        llOwnerSay("Registering with RPC server and retrieving user data from database server...");
        llOpenRemoteDataChannel();  // this sets the object up to accept external XML-RPC calls
    }   

    on_rez(integer startParam)
    {
        llResetScript();
    }

    timer()
    {
        // Every 60 seconds, retrieve the online status from the SL database server
        onlineStatusRequest = llRequestAgentData(avatar, DATA_ONLINE);
        llSetText(avatarName + " is " + onlineStatus, ZERO_VECTOR, 1.0);    // set the hover text
    }

    dataserver(key queryid, string data)
    {
        // this is what SL returns to us when we call llRequestAgentData()
        if (queryid == onlineStatusRequest) // check if it’s the correct request
        {
            if (data == "1")    // online status is just 0 or 1
                onlineStatus = "online";
            else
                onlineStatus = "offline";
        }
    }

    remote_data(integer event_type, key channel, key message_id, string sender, integer idata, string sdata)
    {
        if (event_type == REMOTE_DATA_CHANNEL)
        {
            // SL has set up a channel for the XML-RPC calls
            llOwnerSay("Channel id "+(string)channel);
            llOwnerSay("Sending channel id to web server…");
            // We’ll save it, by sending it to our server
            webResponse = llHTTPRequest("http://" + http_host + "/wp-content/plugins/online-status-insl/save-channel.php",
                        [HTTP_METHOD, "POST",
                        HTTP_MIMETYPE, "application/x-www-form-urlencoded"],
                        "channel=" + (string)channel);
        }
        if (event_type == REMOTE_DATA_REQUEST)
        {
            // This is a call made from our web site/blog asking us for the online status
            llRemoteDataReply(channel, message_id, onlineStatus, idata);
        }
    }

    http_response(key request_id, integer status, list metadata, string body)
    {
        if (request_id == webResponse)
        {
            if (status == 200)  // we’ll get a 200 OK status if the web server stored the XML-RPC channel correctly
                llOwnerSay("Channel id successfully saved");
            else llOwnerSay("Webserver error " + (string)status + ": " + body);
        }
    }
}
</pre>
<p>

<?php _e("Then you can drag the appropriate widget on your sidebar."); 
	}

	add_action('widgets_init', 'online_status_insl_widget_init');
	add_action('admin_menu', 'online_status_insl_admin_menu_options');
 	register_activation_hook(__FILE__, 'online_status_insl_widget_activate');
 	register_deactivation_hook(__FILE__, 'online_status_insl_widget_deactivate');
}
 
$wpdpd = new online_status_insl();
 
?>